import os

from flask import Flask
from datetime import datetime

def create_app(test_config=None):
    app = Flask(__name__, instance_relative_config=True)
    app.config.from_mapping(
        SECRET_KEY='dev',
        DATABASE=os.path.join(app.instance_path, 'weather.sqlite'),
    )

    if test_config is None:
        app.config.from_pyfile('config.py', silent=True)
    else:
        app.config.from_mapping(test_config)

    try:
        os.makedirs(app.instance_path)
    except OSError:
        pass

    @app.template_filter('format_datetime')
    def format_datetime(value, format):
        return datetime.strptime(value, "%Y-%m-%d %H:%M:%S").strftime(format)

    from . import db
    db.init_app(app)

    from . import weather
    app.register_blueprint(weather.bp)
    app.add_url_rule('/', endpoint='index')

    from . import api
    app.register_blueprint(api.bp)
    app.add_url_rule('/api', endpoint='api')

    return app
